package Chan;

use pLog;
use strict;


sub new {
    my ($class, $name, $flags, $key) = (shift, shift, shift, shift);

    my $self = {
      name     => $name,
      flags    => $flags,
      key      => $key,
      log      => new pLog($name),
      logging  => 'off',	#don't log
      auto_op  => 'off',	#don't give op
      fortune  => 'off',	#don't display fortune
      time_on_join  => 'off',	#don't display time
      };
    
    bless $self, $class;
    return $self;
}

sub join {
    my $self = shift;
    my $priv_conn = shift;

    if($self->{logging} eq 'on') {
	$self->{log}->open;
    }
    if($self->{key} ne '') {
      $priv_conn->join($self->{name}, $self->{key});
    } else {
      $priv_conn->join($self->{name});
    }
}

sub part {
    my $self = shift;
    my $priv_conn = shift;
    
    $priv_conn->part($self->{name});
    $self->{log}->close;
}

sub log_write {
    my $self = shift;
    if($self->{logging} eq 'on') {
	$self->{log}->write(@_);
    }
}

sub name {
    my $self = shift;
    $self->{name} = shift if @_;
    return $self->{name};
}

sub flags {
    my $self = shift;
    $self->{flags} = shift if @_;
    return $self->{flags};
}

sub logging {
    my $self = shift;
    $self->{logging} = shift if @_;
    return $self->{logging};
}

sub auto_op {
    my $self = shift;
    $self->{auto_op} = shift if @_;
    return $self->{auto_op};
}

sub fortune {
    my $self = shift;
    $self->{fortune} = shift if @_;
    return $self->{fortune};
}

sub time_on_join {
    my $self = shift;
    $self->{time_on_join} = shift if @_;
    return $self->{time_on_join};
}

1;
