#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>

#define BUFFER_SIZE 		1024
#define SYNOPSIS_START_CODE	"SYNOPSIS"
#define NAME_START_CODE		"NAME"

void strip_terminalcode(char *str);

int main(int argc, char *argv[])
{
	FILE *fp;
	char buffer[BUFFER_SIZE], *ptrpnt;
	int  state=0;
	char startcode[256];
	
	if(argc<2) {
		fprintf(stderr, "What do you want?\n");
		return 0;
	}
	
	if(strstr(argv[0], "manname")) {
		strcpy(startcode, NAME_START_CODE);
	} else {
		strcpy(startcode, SYNOPSIS_START_CODE);
	}
	
	ptrpnt=strchr(argv[1], ' ');
	if(ptrpnt) {
		*ptrpnt=NULL;
		ptrpnt++;
		sprintf(buffer, "man \"%s\" \"%s\"", argv[1], ptrpnt);
	} else {
		sprintf(buffer, "man \"%s\"", argv[1]);
	}
	
	fp=popen(buffer, "r");
	if(fp==NULL) {
		fprintf(stdout, "Can't open man program\n");
		return 0;
	}
	
	while(!feof(fp)) {
		if(!fgets(buffer, BUFFER_SIZE, fp))
			continue;
		strip_terminalcode(buffer);
		switch(state) {
		case 0:	/* not started */
			if(!strncmp(buffer, startcode, strlen(startcode)))
				state=1;
			break;
		case 1: /* printing.. */
			if(isupper(*buffer))
				state=2;
			else 
				if(*buffer)
					fprintf(stdout, "%s\n", buffer);
			break;
		case 2:
			goto getoutofhere;
		}
	}
getoutofhere:	
	pclose(fp);

	return NULL;
}

void strip_terminalcode(char *str)
{
	char buffer[BUFFER_SIZE];
	char *bufcur=buffer;
	char *strorg=str;
	
	while(*str) {
		if(*(str+1)<' ' && *(str+1)<'\n')
			str++;
		else {
			*(bufcur++)=*str;
		}
		if(!*str) break;
		str++;
	}
	
	*bufcur=NULL;
	
	strcpy(strorg, buffer);
}
