#!/usr/bin/perl
#
# @(#)$Id: perlbot.pl,v 1.1.1.1 2002/09/03 09:14:56 tolkien Exp $
#

# Perlbot (name needs to be changed...)
#
# Simple IRC bot for maintaining channels, passing notes,
# eventually network bridging (hopefully... [nope, that's scratched now :] )

use Net::IRC;
use strict;

use Chan;
use Network;
use Perlbot;
use PerlbotCore;

# from Perlbot.pm
$debug = 1;

if($^O =~ /mac/i) {
  $dirsep = ':';
} else {
  $dirsep = '/';
}

my $irc;
my $pid;
my ($server, $port, $ircname);


# from Perlbot.pm
$VERSION = '1.1.9';
$AUTHORS = 'jmuhlich@jhu.edu, burke@pas.rochester.edu';

# Let the user specify a config file as the first command line param, or
# default to 'config'.
$PerlbotCore::CONFIG = $ARGV[0] ? $ARGV[0] : 'config';
&PerlbotCore::parse_main_config;

$irc = new Net::IRC;
$Perlbot::main_conn =
    $irc->newconn(Nick => $nicks[0],
		  Server => $servers[0]->[0],
		  Port => $servers[0]->[1],
		  Ircname => $servers[0]->[2]);

# Add the core functionality 'plugin' as the first plugin.  We have to stick
# it in @plugins like this because the plugin loading code won't find it since
# it's not under $plugindir and not called XXX::Plugin.  Also, load_plugins
# won't 'use' if we just push it on @plugins, it so we had to do that above.
push @plugins, 'PerlbotCore';
# attempt to load plugins and register their handlers
&load_plugins;

$pid = $$;
#`echo $pid > proxy.pid`;       # disable for win9x. :(
open(FILE, '>proxy.pid');
print FILE $pid;
close(FILE);

$irc->start;

exit(0);

#=================================================================

sub load_plugins {
    push @INC, $plugindir;
    opendir(PDH, $plugindir);
    DIR: foreach (readdir(PDH)) {
	# ignore '.' and '..' silently
	if (/\.\.?/) {
	    next DIR;
	}
	# make sure this plugin isn't in @noload.
	# I hate to do it like this, but grep() was losing for some reason...
	foreach my $nl (@PerlbotCore::noload) {
	    if (lc($_) eq lc($nl)) {
		print "Skipping '$_': noload\n" if $debug;
		next DIR;
	    }
	}
	validate_plugin($_) or next DIR;
	load_one_plugin($_) or next DIR;
    }

    # enable all the handlers for each plugin
    foreach (@plugins) {
	start_plugin($_);
    }
    closedir(PDH);
}
