# Kilsang Kang <pushnpop@hanrmi.com>
#
# ̿ ȸ
#

package Bio::Plugin;

use Perlbot;
use POSIX;
use DB_File;
use vars qw($BIO_DATA_PATH $MAX_KEY);

sub get_hooks {
  return { public => \&on_public, msg => \&on_msg };
}

sub on_public {
  my $conn = shift;
  my $event = shift;
  my $who = $event->{to}[0];

  if ($event->{args}[0] =~ /^-bio/) {
    bio($conn, $event, $who);
  }

}

sub on_msg {
  my $conn = shift;
  my $event = shift;
  my $who = $event->nick;

  if($event->{args}[0] =~ /^-bio/) {
    bio($conn, $event, $who);
  }
}

sub is_leep_year {
  my $year = shift;
  return (($year%4 == 0) && (($year%100 > 0) || ($year%400 == 0))) ? 1 : 0;
}

sub get_month_day {
  my ($year, $month, $day) = @_;
  if ($month == 2) { return (is_leep_year($year) ? 29 : 28); }
  elsif ($month == 4 || $month == 6 || $month == 9 || $month == 11) { return 30; }
  else { return 31; }
}

$BIO_DATA_PATH = $datadir . "/bio.db";

sub bio {
	# Math handling.
	my $conn = shift;
	my $event = shift;
	my $who = shift;
	my $nick = $event->{nick};

	if (!defined($pid = fork)) {
		$conn->privmsg($who, "error in bio, or something...");
		$conn->{_connected} = 0;
		exit 1;
	}

	if ($pid) { # parent
		$SIG{CHLD} = sub { wait; };
		return;
	} else {
    # child...

	my (%H,$h,$maxrow,$key,$biko, @sendbuf);
	$h = tie %H,"DB_File",$BIO_DATA_PATH,O_CREAT|O_RDWR,0644,$DB_BTREE;
	unless ($h) {
		$conn->privmsg($who, ": $!");
		$conn->{_connected} = 0;
		exit 1;
	}

    (my $args = $event->{args}[0]) =~ s/^-bio\s*//;
	my (@argv) = split(/\s+/, $args);
	my ($nick_year, $nick_mon, $nick_mday);
	my ($spec_year, $spec_mon, $spec_mday);
	my $day_count;

	$day_count = 1; # ⺻ 1 

	# μ   - û   ˸
	if ($argv[0] eq '') {
		# DB ãƺ ..
		if ($h->get($nick, $nick_birthday)) {
			$conn->privmsg($who, "$nick »   ֽʽÿ.");
			# ο..
			foreach (@help) {
				$conn->privmsg($nick, $_);
			}
			$conn->{_connected} = 0;
			untie %H;
			exit 1;
		}
		($nick_year,$nick_mon,$nick_mday) = split(/\//, $nick_birthday);
	}
	# ɼ ִ ,  Ȥ Ư ˻
	elsif ($argv[0] =~ /^-/) {
		# 
		if ($argv[0] eq "-u" && $argv[1] =~ /(\d+).(\d+).(\d+)/) {
			$nick_year = $1;
			$nick_mon  = $2;
			$nick_mday = $3;
			$nick_birthday = sprintf("%04d/%02d/%02d", $nick_year,$nick_mon,$nick_mday);
			$h->put($nick, $nick_birthday);
		}
		# ƯϷ ˻
		elsif ($argv[1] =~ /(\d+).(\d+).(\d+)/) {
			$spec_year = $1;
			$spec_mon  = $2;
			$spec_mday = $3;

			#  ϵǾ  ..
			if ($h->get($nick, $nick_birthday)) {
				$conn->privmsg($who, "$nick »   ֽʽÿ.");
				# ο
				foreach (@help) {
					$conn->privmsg($nick, $_);
				}
				$conn->{_connected} = 0;
				untie %H;
				exit 1;
			}
			else {
				($nick_year,$nick_mon,$nick_mday) = split(/\//, $nick_birthday);
			}

			if ($#argv+1 > 2 && int($argv[2])) {
				$day_count = int($argv[2]);
			}
		}
		else {
			#  
			untie %H;
			$conn->{_connected} = 0;
			exit 1;
		}
	}
	# ù° μ ¥ΰ
	elsif ($argv[0] =~ /(\d+).(\d+).(\d+)/) {
		$nick_year = $1;
		$nick_mon  = $2;
		$nick_mday = $3;

		if ($#argv+1 > 1 && int($argv[1])) {
				$day_count = int($argv[1]);
		}

		# ϵǾ ʴٸ...  ϰ, ׷   ¥ ˻
		if ($h->get($nick, $nick_birthday)) {
			$nick_birthday = sprintf("%04d/%02d/%02d", $nick_year,$nick_mon,$nick_mday);
			$h->put($nick, $nick_birthday);
		}
		# ϵǾǷ, Էµ ¥ ̿ ˻
		else {
			$spec_year = $nick_year;
			$spec_mon  = $nick_mon;
			$spec_mday = $nick_mday;
			($nick_year,$nick_mon,$nick_mday) = split(/\//, $nick_birthday);
		}
	}
	else {
		untie %H;
		$conn->{_connected} = 0;
		exit 1;
	}

	untie %H;

	# ¥ 
	if ($spec_year < $nick_year) { $sepc_year = 0; }
	if ($spec_mon > 12 || $spec_mon < 1) { $spec_year = 0; }
	if ($spec_mday > get_month_day($spec_year, $spec_mon)) {
		$spec_mday = get_month_day($spec_year, $spec_mon); }

	my($sec,$min,$hour,$mday,$mon,$year,$dummy);

	#  ̿
	if (!$spec_year) {
		($sec,$min,$hour,$mday,$mon,$year,$dummy) = localtime(time);
		if ($year < 99) { $year += 2000; } else { $year += 1900; }
		$mon++;
	}
	# Ư ˻̸
	else {
		$year = $spec_year;
		$mon  = $spec_mon;
		$mday = $spec_mday;
	}

	my($pis) = 3.141592654;
	my($count) = $mday + (get_month_day($nick_year,$nick_mon) - $nick_mday);
	my($y,$m,$i, @phy, @emo, @men, @int, @chk);
	# ¾ 
	for ($m = $nick_mon+1; $m <= 12; $m++) {
		$count += get_month_day($nick_year,$m);
	}
	#  
	for ($y = $nick_year+1; $y < $year; $y++) {
		for ($m = 1; $m <= 12; $m++) { $count += get_month_day($y, $m); }
	}
	#  
	for ($m = 1; $m < $mon; $m++) {
		$count += get_month_day($year, $m);
	}

	# ִ 7ϰ ڷ
	if ($day_count > 7) { $day_count = 7; }

	#  ϴ īƮ ŭ
	for ($i = 0, --$count; $i <= $day_count; $i++,$count++) {
		$phy[$i] = int sin(($count / 23) * 2 * $pis) * 100;
		$emo[$i] = int sin(($count / 28) * 2 * $pis) * 100;
		$men[$i] = int sin(($count / 33) * 2 * $pis) * 100;
		$int[$i] = int sin(($count / 38) * 2 * $pis) * 100;
	}

	my $tmp = "";

	if (!$spec_year) { $tmp = "() "; }
	$tmp .= sprintf("%4d %02d %02d", $year,$mon,$mday);
	if ($day_count > 1) { $tmp .= "  $day_countϰ"; }

	push(@sendbuf, "$nick  $tmp ̿Դϴ.");

	for ($i = 1; $i <= $day_count; $i++,$mday++) {
		if ($mday > get_month_day($year, $mon, $mday)) {
			$mday = 1;
			if ($mon == 12) { $mon=1; $year++; }
			else { $mon++; }
		}
		if ($day_count > 1) { $tmp = sprintf("%02d/%02d ", $mon, $mday); }
		else { $tmp = ""; }
		$tmp .= sprintf("ü:%3d(%s)  :%3d(%s)  :%3d(%s)  :%3d(%s)",
			$phy[$i], ((int($phy[$i-1]) > int($phy[$i])) ? "" : ""),
			$emo[$i], ((int($emo[$i-1]) > int($emo[$i])) ? "" : ""),
			$men[$i], ((int($men[$i-1]) > int($men[$i])) ? "" : ""),
			$int[$i], ((int($int[$i-1]) > int($int[$i])) ? "" : "")
			);
		push(@sendbuf, $tmp);
	}

	foreach (@sendbuf) {
		$conn->privmsg($who, $_);
	}

    $conn->{_connected} = 0;
    exit 0;

	} # child
}

1;
