# Joh Yong-iL <tolkien@nownuri.net>
# 19991004 first write.
# 19991007 using Net::Daemon

package CMUcl::Plugin;

use Perlbot;
use Socket;
use POSIX;

sub get_hooks {
  return { public => \&on_public, msg => \&on_msg };
}

sub on_public {
  my $conn = shift;
  my $event = shift;
  my $who = $event->{to}[0];

  my $args = $event->{args}[0];
  if ($args =~ /^-lp\s*/) {
    lisp($conn, $event, $who);
  }

}

sub on_msg {
  my $conn = shift;
  my $event = shift;
  my $who = $event->nick;

  my $args = $event->{args}[0];
  if ($args =~ /^-lp\s*/) {
    lisp($conn, $event, $who);
  }
}

sub lisp {
  my $conn = shift;
  my $event = shift;
  my $who = shift;

  if (!defined($pid = fork)) {
    $conn->privmsg($who, "error in CMUcl plugin, or something...");
    $conn->{_connected} = 0;
    exit 1;
  }

  if ($pid) {
    # parent

    $SIG{CHLD} = sub { wait; };
    return;

  } else {
    # child...

    my ($args);
    ($args = $event->{args}[0]) =~ s/^-lp\s*//;
#    $args =~ s/`//g;       # math \"`ls`\"   .
#    $args =~ s/(\s*quit\s*(\d*))//g;  # (quit) 
#    $args =~ s/(\s*exit\s*(\d*))//g;  # (exit) 

  if ($args) {

    my($remote,$port,$iaddr,$paddr,$proto,$line);
    $remote = "localhost";
    $port = "2000";

    if(!defined($iaddr = inet_aton($remote))) {
      $conn->privmsg($chan, "Could not get address for $remote");
      $conn->{_connected} = 0;
      exit 1;
    }
    if(!defined($paddr = sockaddr_in($port, $iaddr))) {
      $conn->privmsg($chan, "Could not get port for $remote");
      $conn->{_connected} = 0;
      exit 1;
    }
    if(!defined($proto = getprotobyname('tcp'))) {
      $conn->privmsg($chan, "Could not get tcp protocol");
      $conn->{_connected} = 0;
      exit 1;
    }

    if(!socket(SOCK, PF_INET, SOCK_STREAM, $proto)) {
      $conn->privmsg($chan, "Could not open socket to $remote");
      $conn->{_connected} = 0;
      exit 1;
    }
    if(!connect(SOCK, $paddr)) {
      $conn->privmsg($chan, "Could not connect to $remote");
      $conn->{_connected} = 0;
      exit 1;
    }

    $args = $args . "\n";

    if(!send(SOCK, $args, 0)) {
      $conn->privmsg($chan, "Could not send to $remote");
      $conn->{_connected} = 0;
      exit 1;
    }

  while (1) {
    SOCK->sysread($line, 256);
    if (length($line) == 0) { last; }

    my @bc = split /\n/, $line;
    foreach $line (@bc) {
      $line =~ s/^\* //;
      if ($line) { $conn->privmsg($who, $line); }
    }
    sleep 2;
  }
    close SOCK;
  }

    $conn->{_connected} = 0;

    exit 0;
  }
}

1;
