# Joh Yong-iL <tolkien@nownuri.net>
# This plugin does calendar using cal.  Prolly needs to be on
# a unix system...

package Cal::Plugin;

use Perlbot;
use POSIX;

sub get_hooks {
  return { public => \&on_public, msg => \&on_msg };
}

sub on_public {
  my $conn = shift;
  my $event = shift;
  my $who = $event->{to}[0];

  if ($event->{args}[0] =~ /^-cal/) {
    math($conn, $event, $who);
  }

}

sub on_msg {
  my $conn = shift;
  my $event = shift;
  my $who = $event->nick;

  if($event->{args}[0] =~ /^-cal/) {
    math($conn, $event, $who);
  }
}

sub math {
    # Math handling.
  my $conn = shift;
  my $event = shift;
  my $who = shift;

  if (!defined($pid = fork)) {
    $conn->privmsg($who, "error in cal, or something...");
    $conn->{_connected} = 0;
    exit 1;
  }

  if ($pid) {
    # parent

    $SIG{CHLD} = sub { wait; };
    return;

  } else {
    # child...

    my $args;
    ($args = $event->{args}[0]) =~ s/^-cal\s*//;
    $args =~ s/[^a-zA-Z0-9 ]//g;	#change sec. policy to positive plan
    $args =~ s/\s+/ /g;			#eat whitespace

    my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst);
    my ($qmon, $qyear);

    ($qmon, $qyear) = split(/ /, $args);
    ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
    $mon++;
    if ($year < 99) {
      $year += 2000;
    } else {
      $year += 1900;
    }
    if ($qmon ne '') {
      if ($qmon < 1 || $qmon > 12) {
        $qmon = $mon;
      }
    } else {
      $qmon = $mon;
    }
    if ($qyear ne '') {
      if ($qyear < 1 || $qyear > 9999) {
        $qyear = $year;
      }
    } else {
      $qyear = $year;
    }
  
    my @cal = `cal $qmon $qyear`;

    foreach $line (@cal) {
      chomp $line;
      $conn->privmsg($who, $line);
    }

    $conn->{_connected} = 0;

    exit 0;

  }
}

1;
