# Joh Yong-iL <tolkien@nownuri.net>
#   $args =~ s/`//g;       # remove secury hole like -math "`ls`"
#   $args =~ s/"//g;       # remove secury hole like -math "; /bin/ls  ; "

package Dice::Plugin;

use Perlbot;
use POSIX;

sub get_hooks {
  return { public => \&on_public, msg => \&on_msg };
}

sub on_public {
  my $conn = shift;
  my $event = shift;
  my $who = $event->{to}[0];

  if ($event->{args}[0] =~ /^-dice/) {
    dice($conn, $event, $who);
  }

}

sub on_msg {
  my $conn = shift;
  my $event = shift;
  my $who = $event->nick;

  if($event->{args}[0] =~ /^-dice/) {
    dice($conn, $event, $who);
  }
}

sub dice {
    # Math handling.
  my $conn = shift;
  my $event = shift;
  my $who = shift;

  if (!defined($pid = fork)) {
    $conn->privmsg($who, "error in roll, or something...");
    $conn->{_connected} = 0;
    exit 1;
  }

  if ($pid) {
    # parent

    $SIG{CHLD} = sub { wait; };
    return;

  } else {
    # child...

    my $args;
    ($args = $event->{args}[0]) =~ s/^-dice*//;

    $args =~ s/\s*//g;     #eat whitespace
    $args =~ s/[^d0-9\+\*\- ]//g;
			#change sec. policy to positive plan

    my @bc = `roll $args 2>&1`;
    $conn->privmsg($who, $bc[2]);
    $conn->privmsg($who, $bc[3]);
    
#    foreach my $line (@bc) {
#      chomp $line;
#      $conn->privmsg($who, $line);
#    }
    $conn->{_connected} = 0;

    exit 0;
  }
}

1;
