# Joh Yong-iL <tolkien@nownuri.net>
# Date  : $Date: 2002/09/03 09:15:12 $

package Edic::Plugin;

use Perlbot;
use POSIX;

sub get_hooks {
  return { public => \&on_public, msg => \&on_msg};
}

sub on_public {
  my $conn = shift;
  my $event = shift;

  if ($event->{args}[0] =~ /^-edic/) {
    edic($conn, $event, $event->{to}[0]);
  }
}

sub on_msg {
  my $conn = shift;
  my $event = shift;

  if ($event->{args}[0] =~ /^-edic/) {
    edic($conn, $event, $event->nick);
  }
}

sub edic {
  my $conn = shift;
  my $event = shift;
  my $who = shift;
  my $in;

  if (!defined($pid = fork)) {
    $conn->privmsg($chan, "error in edic... weird.");
    return;
  }

  if ($pid) {
    # parent

    $SIG{CHLD} = sub { wait; };
    return;

  } else {
    # child...

    ($in = $event->{args}[0]) =~ s/^-edic\s*//;
    $in =~ s/[^a-zA-Z0-9 ]//g;	#change sec. policy to positive plan

    if ($in ne '') {
      (my $hd = substr($in, 0, 1)) =~ tr/A-Z/a-z/;
      open FD, $datadir . "/engdic/${hd}.dic" || goto EXIT_EDIC;
      @foo = grep(/^$in\[/, <FD>);
      for(my $i=0; $i <= $#foo; $i++) {
	$foo[$i] =~ s/
//g;
	$conn->privmsg($who, $foo[$i]);
      }
      close FD;
    }

EXIT_EDIC:
    $conn->{_connected} = 0;
    exit 0;                     # kill child
  }
}

1;
