# Joh Yong-iL <tolkien@nownuri.net>

package Fortune::Plugin;

use Perlbot;
use POSIX;

sub get_hooks {
  return { public => \&on_public, msg => \&on_msg, join => \&on_join };
}

sub on_public {
  my $conn = shift;
  my $event = shift;
  my $args;
  ($args = $event->{args}[0]) =~ tr/[A-Z]/[a-z]/;

  if(($args =~ /^-fortune/) || ($args =~ /^-ft/)) {
    disp_fortune($conn, $event, $event->{to}[0]);
  }
}

sub on_msg {
  my $conn = shift;
  my $event = shift;
  my $args;
  ($args = $event->{args}[0]) =~ tr/[A-Z]/[a-z]/;

  if(($args =~ /^-fortune/) || ($args =~ /^-ft/)) {
    disp_fortune($conn, $event, $event->nick);
  }
}

sub on_join {
  my ($conn, $event) = @_;
  my $nick = $event->nick;
  my $chan = ($event->to)[0]; #don't ask me, yo...

  if($channels{to_channel($chan)}->fortune eq "on") {
    disp_fortune($conn, $event, $chan);
  }
}

sub disp_fortune {
  my $conn = shift;
  my $event = shift;
  my $who = shift;

  my @tmp = `/usr/games/fortune`; 

  foreach my $line (@tmp) {
    $conn->privmsg($who, $line);
  }
  return;
}

1;
