# Perlbot IPWhereIs Module
#
# by perky <perky@python.or.kr>
#

package IPWhereIs::Plugin;

use Perlbot;
use POSIX;

sub get_hooks {
	return { public => \&on_public, msg => \&on_msg};
}

sub on_public {
	my $conn = shift;
	my $event = shift;
	
	(my $args = $event->{args}[0]) =~ tr/[A-Z]/[a-z]/;
	
	if($args =~ /^-(whereis|ip)\s*/) {
		funct($conn, $event, $event->{to}[0], 1);
	}
}

sub on_msg {
	my $conn = shift;
	my $event = shift;
	
	(my $args = $event->{args}[0]) =~ tr/[A-Z]/[a-z]/;

	if($args =~ /^-(whereis|ip)\s*/) {
		funct($conn, $event, $event->nick, 0);
	}
}

sub funct {
	my $conn = shift;
	my $event = shift;
	my $who = shift;
	my $limit = shift;
	my $in;
	my $task=0;
	
	if (!defined($pid = fork)) {
		$conn->privmsg($chan, "error in converting... weird.");
		return;
	}
	
	if ($pid) {
		# parent
		
		$SIG{CHLD} = sub { wait; };
		return;

	} else {
		# child...
		
		$in = $event->{args}[0];
		$in  =~ s/^-(whereis|ip)\s*//;
		
		$in =~ s/\\//g;
		$in =~ s/\`//g;
		$in =~ s/\"//g;
		$in =~ s/\$//g;
		$in =~ s/\;//g;
		
		if ($in ne '') {
			my @tr = `data/bin/ipwhereis_irc \"$in\" 2>/dev/null`;
			my $i;
			$i=0;
			
			foreach $line (@tr) {
				if($i>4 && $limit) {
					$conn->privmsg($who, "For more information, type /msg chicken -man $in");
					goto goout1;
				}
				chomp $line;
				$conn->privmsg($who, $line);
				$i++;
			}
			goout1: ;
		}
		
		$conn->{_connected} = 0;
		exit 0;                     # kill child
	}
}

1;
