#
# Korail
#
# Author      : Kilsang Kang
# Revision    : $Revision: 1.1.1.1 $
# Last Update : $Date: 2002/09/03 09:15:12 $
#
package Korail::Plugin;

use Perlbot;
use Socket;
use POSIX;

sub get_hooks {
	return { public => \&on_public, msg => \&on_msg};
}

sub on_public {
	my $conn = shift;
	my $event = shift;

	(my $args = $event->{args}[0]) =~ tr/[A-Z]/[a-z]/;

	if($args =~ /^-\s*/) {
		get_korail($conn, $event, $event->{to}[0], 1);
	}
}

sub on_msg {
	my $conn = shift;
	my $event = shift;

	(my $args = $event->{args}[0]) =~ tr/[A-Z]/[a-z]/;

	if($args =~ /^-\s*/) {
		get_korail($conn, $event, $event->nick, 0);
	}
}

use Socket;
use POSIX;

sub get_korail {
	my $conn = shift;
	my $event = shift;
	my $who = shift;

	if (!defined($pid = fork)) {
		$conn->privmsg($chan, "error in  plugin...");
		return;
	}
	if ($pid) {
		$SIG{CHLD} = sub { wait; };
		return;
	}
	else {
		# http://www.korail.go.kr:5003
		# öû: ¶οȸ

		my ($start,$end,$train,$date);
		my ($sec,$min,$hour,$mday,$mon,$year,$dummy);
		my ($train);
		my ($efect);
		my $help = ": -   {|ȭ||ü}|{1|2|3|4} mm:dd[:hh]";

		($sec,$min,$hour,$mday,$mon,$year,$dummy) = localtime(time);
		$year += 2000; $mon++; $hour = 0;

    		($args = $event->{args}[0]) =~ s/^-\s*//;
		@argv = split(/ /, $args);
		$efect = 0;

		if ($#argv < 2) {
			$conn->privmsg($who, $help);
			$conn->{_connected} = 0;
			exit 1;
		}
		elsif ($#argv >= 3) {
			($mon,$mday,$hour) = split(':', $argv[3]);
			$efect = 1 if ($argv[4] eq 'ȿ');
		}
		$mon = sprintf("%02d", $mon);
		$mday = sprintf("%02d", $mday);
		$hour = sprintf("%02d", $hour);

		if ($argv[2] =~ /(|ȭ||ü)/) {
			$train = $argv[2];
			if ($argv[2] eq '')  { $argv[2] = 1; }
			elsif ($argv[2] eq 'ȭ'){$argv[2] = 2; }
			elsif ($argv[2] eq '') { $argv[2] = 3; }
			elsif ($argv[2] eq 'ü') { $argv[2] = 4; }
		}
		elsif ($argv[2] eq '1') { $train = ''; }
		elsif ($argv[2] eq '2') { $train = 'ȭ'; }
		elsif ($argv[2] eq '3') { $train = ''; }
		elsif ($argv[2] eq '4') { $train = 'ü'; }
		else {
			$conn->privmsg($who, $help);
			$conn->{_connected} = 0;
			exit 1;
		}

		my($remote,$port,$iaddr,$paddr,$proto,$line);
		$remote = "www.korail.go.kr";
		$port = "80";

		if(!defined($iaddr = inet_aton($remote))) {
			$conn->privmsg($who, "Could not get address of $remote");
			$conn->{_connected} = 0;
			exit 1;
		}
		if(!defined($paddr = sockaddr_in($port, $iaddr))) {
			$conn->privmsg($who, "Could not get port address of $remote");
			$conn->{_connected} = 0;
			exit 1;
		}
		if(!defined($proto = getprotobyname('tcp'))) {
			$conn->privmsg($who, "Could not get tcp connection for $remote");
			$conn->{_connected} = 0;
			exit 1;
		}
		if(!socket(SOCK, PF_INET, SOCK_STREAM, $proto)) {
			$conn->privmsg($who, "Could not establish socket connect to $remote");
			$conn->{_connected} = 0;
			exit 1;
		}
		if(!connect(SOCK, $paddr)) {
			$conn->privmsg($who, "Could not establish connection to $remote");
			$conn->{_connected} = 0;
			exit 1;
		}

		$get= "GET /cgi-bin/X_msgtop?portid=00&chnlid=00&inquire=80&start_station=001"
			. "&arrive_station=020&min=00&scode=001&acode=020&start=$argv[0]&end=$argv[1]&year="
			. "$year&mon=$mon&day=$mday&dayofweek=&time=$hour&train_grade=$argv[2]&seat_class=1"
			. " HTTP/1.0\n\n";

		if (!send(SOCK, $get, 0)) {
			$conn->privmsg($who, "Could not establish send to $remote");
			$conn->{_connected} = 0;
			exit 1;
		}

		my(@line, @rows, @cols, @temp, $tr, $td, $buf, $temp, $ts);

		while($buf = <SOCK>) {
			if ($buf =~ /^<tr><td rowspan=2/) {
				@rows = split(/<tr>/, $buf);
				foreach $tr (@rows) {
					next if ($tr =~ /(Ȯ|Ϲݽ)/);
					$tr =~ s/<td /<td></gi;
					@cols = split(/<td>/, $tr);
					$temp = "";
					$ts = "";

					foreach $td (@cols) {
						# ü ˻ ڵ
						if (($argv[2] == 4 && $ts eq '') && ($td =~ /bgcolor=([A-Za-z0-9]{6})/)) {
							my $bgcolor = $1;
							if    ($bgcolor eq '99ccff') { $ts = 'ȣ'; }
							elsif ($bgcolor eq 'ffe188') { $ts = 'ȭȣ'; }
							else  { $ts = 'ȣ'; }
						}
						$td =~ s/<\/td>.*$//;
						$td =~ s/<[^>]+>//g;
						$td =~ s/&nbsp;//g;
						$td =~ s/\n*//g;
						next if ($td eq '');
						$temp .= "$td,";
					}
					if ($temp ne '') {
						if ($ts ne '') { $temp .= " ($ts)"; }
						push(@line, $temp);
					}
				}
				last;
			}
		} # END OF while

		close(SOCK);

		if ($#line < 0) {
			$conn->privmsg($who, " ϴ. ٽ ȸϼ");
		}
		else {
			$max = $#line + 1;
			$conn->privmsg($who, "[[ $train: ${mon} ${mday} ]] $argv[0] > $argv[1] ($max)");
			$conn->privmsg($who, "        Ϲ/Ư//Լ");

			my $ecnt = 0;	# efect count

			foreach $buf (@line) {
				@cols = split(/,/, $buf);
				if (!$cols[6] || $cols[6] == '') { $cols[6] = '-'; }
				# by biko, 2001-11-17
				$enum = int($cols[3]) + int($cols[4]);
				if (!$efect or ($efect and $enum)) {
					$temp = sprintf("%3s   %5s  %5s  %4s/%4s/%4s/%4s%s",$cols[0],$cols[1],$cols[2],$cols[3],$cols[4],$cols[5],$cols[6],$cols[7]);
					if ($efect) {
						$temp .= " [ȿ:$enum]";
						$ecnt++;
					}
					$conn->privmsg($who, $temp);
				}
			}
			if ($efect and !$ecnt) {
				$conn->privmsg($who, "ȿ  ϴ. ٽ ȸϼ.");
			}
		}

    	$conn->{_connected} = 0;
    	exit 0;
	}
}

1;
