# JunSeon Oh <holywar@mail.holynet.co.kr>
#
# latest Linux's Kernel version.

package LinuxKernel::Plugin;

use Perlbot;
use POSIX;

sub get_hooks {
  return { public => \&on_public, msg => \&on_msg};
}

sub on_public {
  my $conn = shift;
  my $event = shift;

  (my $args = $event->{args}[0]) =~ tr/[A-Z]/[a-z]/;

  if($args =~ /^-linuxkernel\s*/ || $args =~ /^-lk\s*/) {
    troute($conn, $event, $event->{to}[0]);
  }
}

sub on_msg {
  my $conn = shift;
  my $event = shift;

  (my $args = $event->{args}[0]) =~ tr/[A-Z]/[a-z]/;

  if($args =~ /^-linuxkernel\s*/ || $args =~ /^-lk\s*/) {
    troute($conn, $event, $event->nick);
  }
}

sub troute {
  my $conn = shift;
  my $event = shift;
  my $who = shift;
  my $in;

  if (!defined($pid = fork)) {
    $conn->privmsg($chan, "error in finger... weird.");
    return;
  }

  if ($pid) {
    # parent

    $SIG{CHLD} = sub { wait; };
    return;

  } else {
    # child...

    (my $in = $event->{args}[0]) =~ s/^-linuxkernel\s*//;
    $in =~ s/^-lk\s*//;

    my @tr = `finger \@ftp.kernel.org`;

    for(my $i=1; $i < $#tr; $i++) {
      $conn->privmsg($who, $tr[$i]);
    }

    $conn->{_connected} = 0;
    exit 0;                     # kill child
  }
}

1;
