# Joh, Yong-iL <tolkien@nownuri.net>
#
# This gets the latest Linuxtoday entries.

package Linuxtoday::Plugin;

use Perlbot;

use POSIX;
require HTML::TokeParser;

sub get_hooks {
  return { public => \&on_public, msg => \&on_msg };
}

sub on_public {
  my $conn = shift;
  my $event = shift;
  my $args;

  ($args = $event->{args}[0]) =~ tr/[A-Z]/[a-z]/;

  if($args =~ /^-linuxtoday\s*/  || $args =~ /^-lt\s*/) {
    get_lt($conn, $event, $event->{to}[0]);
  }
}

sub on_msg {
  my $conn = shift;
  my $event = shift;
  my $args;
 
  ($args = $event->{args}[0]) =~ tr/[A-Z]/[a-z]/;

  if($args =~ /^-linuxtoday\s*/  || $args =~ /^-lt\s*/) {
    get_lt($conn, $event, $event->nick);
  }
}

sub get_lt {
  my $conn = shift;
  my $event = shift;
  my $who = shift;
  my $max;

  ($max = $event->{args}[0]) =~ tr/[A-Z]/[a-z]/;
  $max =~ s/^-linuxtoday\s*//;
  $max =~ s/^-lt\s*//;
  $max =~ s/\s+(\d+)\s*.*/\1/;

  if($max eq '') { $max = 5; }

  if(!defined($pid = fork)) {
    $conn->privmsg($who, "error in linuxtoday plugin...");
    return;
  }

  if($pid) {
    #parent
    
    $SIG{CHLD} = sub { wait; };
    return;

  } else {
    # child

    open FILE, $datadir . "/Linuxtoday.dat";

    $conn->privmsg($who, "Today's Newswire:");

    my $headline = '';
    my $author = '';
    my $date = '';

    my $i = 0;
    my $p = HTML::TokeParser->new(*FILE) || die "Can't open: $!";

    for(my $j=0; $j < 4; $j++) {
	$p->get_tag("form");
    }
    for(my $j=0; $j < 2; $j++) {
	$p->get_tag("a");
    }

    while (my $token = $p->get_token) {
	$p->get_tag("a");
	$headline = $p->get_trimmed_text("/a");
	$p->get_tag("font");
	($date, $author) = $p->get_trimmed_text("/font")
		=~ /\((.*)UTC.*Posted by(.*)\)/;

	my ($year) = $date =~ /.*?(\d\d\d\d).*?/;
	my ($month) = $date =~ /.*?(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec).*?/;
	my ($day) = $date =~ /.*?(\d+),/;
	my ($time) = $date =~ /,\s*(\d+:\d+).*?/;
	$month =~ s/Jan/1/;
	$month =~ s/Feb/2/;
	$month =~ s/Mar/3/;
	$month =~ s/Apr/4/;
	$month =~ s/May/5/;
	$month =~ s/Jun/6/;
	$month =~ s/Jul/7/;
	$month =~ s/Aug/8/;
	$month =~ s/Sep/9/;
	$month =~ s/Oct/10/;
	$month =~ s/Nov/11/;
	$month =~ s/Dec/12/;

	if($i > $max) { last; }
	my $output = sprintf("[%d/%2d/%2d %s] %s\n", $year, $month, $day, $time, $headline);
	$conn->privmsg($who, $output);
	$i++;
	next;
    }

    close FILE;
    $conn->{_connected} = 0;
    exit 0;
  }
}

1;
