# Andrew Burke <burke@pas.rochester.edu>
#
# This plugin does math using bc.  Prolly needs to be on
# a unix system...
#
# Joh Yong-iL <tolkien@nownuri.net>
#   $args =~ s/`//g;       # remove secury hole like -math "`ls`"
#   $args =~ s/"//g;       # remove secury hole like -math "; /bin/ls  ; "

#
# originally ported/mangled from:
# infobot copyright (C) kevin lenzo 1997-98

package Math::Plugin;

use Perlbot;
use POSIX;

sub get_hooks {
  return { public => \&on_public, msg => \&on_msg };
}

sub on_public {
  my $conn = shift;
  my $event = shift;
  my $who = $event->{to}[0];

  if ($event->{args}[0] =~ /^-math/) {
    math($conn, $event, $who);
  }

}

sub on_msg {
  my $conn = shift;
  my $event = shift;
  my $who = $event->nick;

  if($event->{args}[0] =~ /^-math/) {
    math($conn, $event, $who);
  }
}

sub math {
    # Math handling.
  my $conn = shift;
  my $event = shift;
  my $who = shift;

  if (!defined($pid = fork)) {
    $conn->privmsg($who, "error in bc, or something...");
    $conn->{_connected} = 0;
    exit 1;
  }

  if ($pid) {
    # parent

    $SIG{CHLD} = sub { wait; };
    return;

  } else {
    # child...

    my $args;
    ($args = $event->{args}[0]) =~ s/^-math\s*//;

    $args =~ s/\s*//g;     #eat whitespace

    $args =~ s/arctan/a/g; #arctan->a
    $args =~ s/cos/c/g;    #cos->c (the bc function)
    $args =~ s/tan/t/g;    #tan->t
    $args =~ s/sin/s/g;    #sin->s
    $args =~ s/log/l/g;    #log->l
    $args =~ s/[^a-zA-Z0-9\.\=\+\-\*\/\%\^\)\(\]\[\!\>\<\&\|\,\;\{\}\_ ]//g;
			#change sec. policy to positive plan

    my @bc = `echo "$args"|bc -l 2>&1`;

    my $chik = 0;
    foreach my $line (@bc) {
      chomp $line;
      if (($line =~ /illegal/) or (length($line) > 68)) {
	$chik = 1;
      }
      if ($chik == 0) {
	$conn->privmsg($who, $line);
      }
    }
    if ($chik) {
	$conn->privmsg($who, "digit is too large, or syntax error!");
    }
    $conn->{_connected} = 0;

    exit 0;

  }
}

1;
