# Joh Yong-iL <tolkien@nownuri.net>
#   $args =~ s/`//g;       # remove secury hole like !math "`ls`"

package Misc::Plugin;

use Perlbot;
use POSIX;

sub get_hooks {
  return { public => \&on_public, msg => \&on_msg, join => \&on_join };
}

sub on_public {
  my $conn = shift;
  my $event = shift;
  my $args;
  ($args = $event->{args}[0]) =~ tr/[A-Z]/[a-z]/;

  if($args =~ /^-time/) {
    display_localtime($conn, $event, $event->{to}[0]);
  } elsif ($args =~ /^-d2ip/) {
    $args =~ s/^-d2ip\s*//;
    $args =~ s/\s*//g;
    $conn->privmsg($event->{to}[0], d2o($args, 255));
  }
}

sub on_msg {
  my $conn = shift;
  my $event = shift;
  my $args;
  ($args = $event->{args}[0]) =~ tr/[A-Z]/[a-z]/;

  if($args =~ /^-pwd/) {
    pwd($conn, $event, $event->nick);
  } elsif($args =~ /^-time/) {
    display_localtime($conn, $event, $event->nick);
  } elsif ($args =~ /^-d2ip/) {
    $args =~ s/^-d2ip\s*//;
    $args =~ s/\s*//g;
    $conn->privmsg($event->nick, d2o($args, 255));
  }
}

sub on_join {
  my ($conn, $event) = @_;
  my $nick = $event->nick;
  my $chan = ($event->to)[0]; #don't ask me, yo...

    if($channels{to_channel($chan)}->auto_op eq "on") {
      $conn->mode($chan, "+\o", $nick);
    }
    if($channels{to_channel($chan)}->time_on_join eq "on") {
      display_localtime($conn, $event, $chan);
    }
}

sub pwd {
  my $conn = shift;
  my $event = shift;
  my $who = shift;

  if (!defined($pid = fork)) {
    $conn->privmsg($who, "fork error...");
    $conn->{_connected} = 0;
    exit 1;
  }

  if ($pid) {
    # parent

    $SIG{CHLD} = sub { wait; };
    return;
  } else {
    # child...

    my $args;
    ($args = $event->{args}[0]) =~ s/^-pwd\s*//;
    $args =~ s/\s*//g;     #eat whitespace

    if ($args ne '') {
      srand (time ^ $$ ^ unpack "%L*", `ps axww | gzip`);
      my $i = rand();
      my $j = substr($i, 2, 2);
      $j = ($j + 32) & 0x7f;
      my $pwd = chr($j);
      $j = substr($i, 4, 2);
      $j = ($j + 32) & 0x7f;
      $pwd = crypt($args, $pwd . chr($j));
      $conn->privmsg($who, $pwd);
    } else {
      $conn->privmsg($who, "please, submit your passwd!");
    }

    $conn->{_connected} = 0;
    exit 0;
  }
}

sub display_localtime {
  my $conn = shift;
  my $event = shift;
  my $who = shift;
  my ($sec,$min,$hour,$mday,$mon,$year);

  ($sec,$min,$hour,$mday,$mon,$year) = localtime;
  $year += 1900;
  $mon += 1;

  $conn->privmsg($who, "[$year/$mon/$mday $hour:$min:$sec]");

  return;
}

sub d2o {
    my $in = shift;
    my $mod = shift;
    my ($rem, $out);

    $rem = $in % $mod;
    $out = ($in - $rem) / $mod;
    if ($out != 0) {
        return $rem . "." . d2o($out, $mod);
    } else {
        return $in . ".";
    }
}

1;
