#
# @(#)OhMyNews/Plugin.pm
#
# This gets the latest  news
#
# Author      : Kilsang Kang <biko@kang.sarang.net>
# Date        : 2001/06/07 ()
# Revision    : $Revision: 1.1.1.1 $
# Last Update : $Date: 2002/09/03 09:15:12 $
#

package OhMyNews::Plugin;

use Perlbot;
use POSIX;
use HTML::TokeParser;
use HTTP::Lite;

sub get_hooks {
  return { public => \&on_public, msg => \&on_msg };
}

sub on_public {
  my $conn = shift;
  my $event = shift;
  my $args;

  ($args = $event->{args}[0]) =~ tr/[A-Z]/[a-z]/;

  if($args =~ /^-ohmy\s*/) {
    get_ohmynews($conn, $event, $event->{to}[0]);
  }
}

sub on_msg {
  my $conn = shift;
  my $event = shift;
  my $args;

  ($args = $event->{args}[0]) =~ tr/[A-Z]/[a-z]/;

  if($args =~ /^-ohmy\s*/) {
    get_ohmynews($conn, $event, $event->nick);
  }
}

sub get_ohmynews {
  my $conn  = shift;
  my $event = shift;
  my $who   = shift;
  my $args  = $event->{args}[0];
  my $max   = "";

  $args =~ tr/[A-Z]/[a-z]/;
  $args =~ s/^-ohmy\s*//;

  my @argv = split(/ /, $args);
  my %SECTION = (
  'c10100'	=> ['ȸ'],
  'c10200'	=> ['ȭ'],
  'c10300'	=> ['ġ'],
  'c10400'	=> [''],
  'c10500'	=> [''],
  'c10600'	=> [''],
  'c10700'	=> [''],
  'c10800'	=> [''],
  );
  my $section = '';
  my $limit = 5;

  if ($#argv > -1) {
    foreach my $key (keys %SECTION) {
      foreach (@{$SECTION{$key}}) {
        if (/$argv[0]/) { $section = $key; last; }
      }
      last if ($section);
    }
  }
  $limit = int($argv[$#argv]) if($argv[$#argv] =~ /^(\d+)$/);
  $limit = 5 if ($limit <= 0);
  $limit =20 if ($limit > 20);

  if(!defined($pid = fork)) {
    $conn->privmsg($who, "error in ̴ plugin...");
    return;
  }

  if($pid) {
    #parent
  
    $SIG{CHLD} = sub { wait; };
    return;
  
  } else {
    # child

    $conn->privmsg($who, "̴(http://www.ohmynews.com/)");

    my $stat = 0;
    my $http = new HTTP::Lite;
    my $url  = "http://www.ohmynews.com/open_all_list.asp?pvel=open%5Fall%5Flist&page=1&field%5Fname=current%5Flevel&levelClass=ingul";
    if ($section) { $url="http://www.ohmynews.com/class_view.asp?menu=${section}"; }
  
    if (($stat = $http->request($url)) != 200) {
       $conn->privmsg($who, "server error: $stat");
       $conn->{_connected} = 0;
       exit 0;
    }

    my $p = HTML::TokeParser->new(\$http->body) || die "Can't open: $!\n";

    while(my $token = $p->get_tag("a")) {
      if ($token->[1]{href} =~ /article_view.asp\?menu=([c0-9]*)&no=(\d+)/) {
        my $sec = $SECTION{$1}[0];
        my $num = $2;
        my $text= $p->get_trimmed_text("/a");

        $text =~ s/\[IMG\]//;
        $text =~ s/^\s*//;
        $text =~ s/\s*$//;

        next unless ($text);

        my $send= "";
        $send .= "[".$SECTION{$section}[0]."] " if ($section ne '');
        $send .= $text;

        $conn->privmsg($who, "$send");

        last unless(--$limit);
      }
    }

    $conn->{_connected} = 0;
    exit 0;
  }
}

1;
