# Joh, Yong-iL <tolkien@nownuri.net>
#
#    ְ (http://kr.finance.yahoo.com/)

package Pax::Plugin;

use Perlbot;

use Socket;
use POSIX;
require HTML::TokeParser;

sub get_hooks {
  return { public => \&on_public, msg => \&on_msg };
}

sub on_public {
  my $conn = shift;
  my $event = shift;
  my $args;

  ($args = $event->{args}[0]) =~ tr/[A-Z]/[a-z]/;

  if($args =~ /^-pax/) {
      get_pax($conn, $event, $event->{to}[0]);
  }
}

sub on_msg {
  my $conn = shift;
  my $event = shift;
  my $args;

  ($args = $event->{args}[0]) =~ tr/[A-Z]/[a-z]/;

  if($args =~ /^-pax/) {
      get_pax($conn, $event, $event->nick);
  }
}

sub get_pax {
  my $conn = shift;
  my $event = shift;
  my $who = shift;

  $args = $event->{args}[0];
  $args =~ s/^-pax\s*//;
  $args =~ s/\s+/ /g;
  my($company, $empty) = split(/ /, $args, 2);

  if(!defined($pid = fork)) {
    $conn->privmsg($who, "error in Pax plugin...");
    return;
  }

  if($pid) {
    #parent

    $SIG{CHLD} = sub { wait; };
    return;

  } else {
    # child

    if ($company ne '') {
	$msg = "GET /q?s=" . $company . "&d=v1\n\n";
	get_HTTP($conn, $who, "kr.finance.yahoo.com", "80", $msg);

	my $p = HTML::TokeParser->new(*SOCK) || die "Can't open: $!\n";

	my $token = $p->get_tag("form");
	for(my $i=0; $i < 4; $i++) {
		$token = $p->get_tag("table");
	}
	$token = $p->get_tag("tr");
	$token = $p->get_tag("tr");
	my $code = $p->get_trimmed_text("/td");
	$token = $p->get_tag("td");
	my $name = $p->get_trimmed_text("/td");
	if ($name =~ / ʽϴ/) {
	  $conn->privmsg($who, "  ڵ($company) ϴ.\n");
	} else {
	  $token = $p->get_tag("td");
	  my $last_time = $p->get_trimmed_text("/td");
	  $token = $p->get_tag("td");
	  my $last_value = $p->get_trimmed_text("/td");
	  $token = $p->get_tag("td");
	  my $change = $p->get_trimmed_text("/td");
	  $token = $p->get_tag("td");
	  my $change_p = $p->get_trimmed_text("/td");
	  $token = $p->get_tag("td");
	  my $qty = $p->get_trimmed_text("/td");

	  $conn->privmsg($who, "  : $name($code) ŷ: $qty\n");
	  $conn->privmsg($who, "  ŷ: $last_value ($last_time)\n");
	  $conn->privmsg($who, "  : $change ($change_p)\n");
	}
    } else {
	$msg = "GET /\n\n";
	get_HTTP($conn, $who, "kr.finance.yahoo.com", "80", $msg);

	my $p = HTML::TokeParser->new(*SOCK) || die "Can't open: $!\n";

	$conn->privmsg($who, "ְ (20 delayed)");
	my $token = $p->get_tag("table");
	$token = $p->get_tag("table");

	$token = $p->get_tag("table");
	$token = $p->get_tag("td");
	$token = $p->get_tag("td");
	my $jisu = $p->get_trimmed_text("/td");
	$token = $p->get_tag("td");
	my $jisu_change = $p->get_trimmed_text("/td");

	$token = $p->get_tag("table");
	$token = $p->get_tag("td");
	$token = $p->get_tag("td");
	my $kosdaq = $p->get_trimmed_text("/td");
	$token = $p->get_tag("td");
	my $kosdaq_change = $p->get_trimmed_text("/td");

	$token = $p->get_tag("table");
	$token = $p->get_tag("td");
	$token = $p->get_tag("td");
	my $kospi200 = $p->get_trimmed_text("/td");
	$token = $p->get_tag("td");
	my $kospi200_change = $p->get_trimmed_text("/td");

	$token = $p->get_tag("table");
	$token = $p->get_tag("table");

	$token = $p->get_tag("table");
	$token = $p->get_tag("td");
	$token = $p->get_tag("td");
	my $pre = $p->get_trimmed_text("/td");
	$token = $p->get_tag("td");
	my $pre_change = $p->get_trimmed_text("/td");

	$conn->privmsg($who, "  ְ: $jisu $jisu_change\n");
	$conn->privmsg($who, "  KOSPI200: $kospi200 $kospi200_change\n");
	$conn->privmsg($who, "  KOSDAQ:   $kosdaq $kosdaq_change\n");
	$conn->privmsg($who, "  :  $pre $pre_change\n");
    }

    close SOCK;
    $conn->{_connected} = 0;
    exit 0;
  }
  close SOCK;
}

# This is a simple http connection
sub get_HTTP {
    my $conn = shift;
    my $who = shift;
    my $remote = shift;
    my $port = shift;
    my $msg = shift;
    my($iaddr,$paddr,$proto,$line);

    if(!defined($iaddr = inet_aton($remote))) {
      $conn->privmsg($who, "Could not get address for $remote");
      $conn->{_connected} = 0;
      exit 1;
    }
    if(!defined($paddr = sockaddr_in($port, $iaddr))) {
      $conn->privmsg($who, "Could not get port for $remote");
      $conn->{_connected} = 0;
      exit 1;
    }
    if(!defined($proto = getprotobyname('tcp'))) {
      $conn->privmsg($who, "Could not get tcp protocol");
      $conn->{_connected} = 0;
      exit 1;
    }

    if(!socket(SOCK, PF_INET, SOCK_STREAM, $proto)) {
      $conn->privmsg($who, "Could not open socket to $remote");
      $conn->{_connected} = 0;
      exit 1;
    }
    if(!connect(SOCK, $paddr)) {
      $conn->privmsg($who, "Could not connect to $remote");
      $conn->{_connected} = 0;
      exit 1;
    }
    if(!send(SOCK, $msg, 0)) {
      $conn->privmsg($who, "Could not send to $remote");
      $conn->{_connected} = 0;
      exit 1;
    }

    return;
}

1;
