# Yong-iL Joh <tolkien@mizi.com>
#
# send SMS message to 017

package SMS017::Plugin;

use Perlbot;

use Socket;
use POSIX;

sub get_hooks {
  return { public => \&on_public, msg => \&on_msg };
}

sub on_public {
  my $conn = shift;
  my $event = shift;
  my $args;

  ($args = $event->{args}[0]) =~ tr/[A-Z]/[a-z]/;

  if($args =~ /^-017/) {
    send_sms($conn, $event, $event->{to}[0]);
  }
}

sub on_msg {
  my $conn = shift;
  my $event = shift;
  my $args;

  ($args = $event->{args}[0]) =~ tr/[A-Z]/[a-z]/;

  if($args =~ /^-017/) {
    send_sms($conn, $event, $event->nick);
  }
}

sub send_sms {
  my $conn = shift;
  my $event = shift;
  my $who = shift;
  my $from = $event->nick;
  my ($args, @argv, $msg, $to);

  ($args = $event->{args}[0]) =~ s/^-017\s*//;
  if ($args eq '') { return; }
  (@argv) = split(/\s+/, $args);

  $to = $argv[0];
  $argv[0] = '';
  ($msg = join(' ', @argv)) =~ s/^\s+//;
  if (!($to =~ /^[0-9]+$/)) {
    $conn->privmsg($who, "wrong number... $to");
    return;
  }

  if(!defined($pid = fork)) {
    $conn->privmsg($who, "error in 017 plugin...");
    return;
  }

  if($pid) {
    #parent

    $SIG{CHLD} = sub { wait; };
    return;

  } else {
    # child

    my($remote,$port,$iaddr,$paddr,$proto,$line);
    $remote = '203.226.207.228';
    $port = 25;

    if(!defined($iaddr = inet_aton($remote))) {
      $conn->privmsg($who, "Could not get address for $remote:$port");
      $conn->{_connected} = 0;
      exit 1;
    }
    if(!defined($paddr = sockaddr_in($port, $iaddr))) {
      $conn->privmsg($who, "Could not get port for $remote");
      $conn->{_connected} = 0;
      exit 1;
    }
    if(!defined($proto = getprotobyname('tcp'))) {
      $conn->privmsg($who, "Could not get tcp protocol");
      $conn->{_connected} = 0;
      exit 1;
    }

    if(!socket(SOCK, PF_INET, SOCK_STREAM, $proto)) {
      $conn->privmsg($who, "Could not open socket to $remote");
      $conn->{_connected} = 0;
      exit 1;
    }
    if(!connect(SOCK, $paddr)) {
      $conn->privmsg($who, "Could not connect to $remote:$port");
      $conn->{_connected} = 0;
      exit 1;
    }

    if(!send(SOCK, "HELO\n", 0)) {
      $conn->privmsg($who, "Could not send to $remote");
      $conn->{_connected} = 0;
      exit 1;
    }
    recv(SOCK, $r_msg, 1024, 0);
    send(SOCK, "mail from: <$from>\n", 0);
    recv(SOCK, $r_msg, 1024, 0);
    send(SOCK, "rcpt to: <017$to\@sms.shinsegi.com>\n", 0);
    recv(SOCK, $r_msg, 1024, 0);
    send(SOCK, "data\n", 0);
    recv(SOCK, $r_msg, 1024, 0);
    send(SOCK, "Subject: $msg\n", 0);
    recv(SOCK, $r_msg, 1024, 0);
    send(SOCK, ".\n", 0);
    recv(SOCK, $r_msg, 1024, 0);
    send(SOCK, "quit\n", 0);
    recv(SOCK, $r_msg, 1024, 0);
 
    $conn->privmsg($who,"sent!") ; 

    close SOCK;
    $conn->{_connected} = 0;
    exit 0;
  }

  close SOCK;
}

1;
