# JunSeon Oh <holywar@mail.holywar.net>
#
# This gets the server information

package Server::Plugin;

use Perlbot;

use Socket;
use POSIX;

sub get_hooks {
  return { public => \&on_public, msg => \&on_msg };
}

sub on_public {
  my $conn = shift;
  my $event = shift;
  my $args;

  ($args = $event->{args}[0]) =~ tr/[A-Z]/[a-z]/;

  if($args =~ /^-server\s*/ || $args =~ /^-server\s*/) {
    get_os($conn, $event, $event->{to}[0]);
  }
}

sub on_msg {
  my $conn = shift;
  my $event = shift;
  my $args;

  ($args = $event->{args}[0]) =~ tr/[A-Z]/[a-z]/;

  if($args =~ /^-server\s*/ || $args =~ /^-server\s*/) {
    get_os($conn, $event, $event->nick);
  }
}

sub get_os {
  my $conn = shift;
  my $event = shift;
  my $who = shift;
  my $max;

  ($max = $event->{args}[0]) =~ tr/[A-Z]/[a-z]/;
  $max =~ s/^-server\s*//;
  $max =~ s/\s*//g;
  $max =~ s/:.*// ;
  if ($max eq '') { return; }

  if(!defined($pid = fork)) {
    $conn->privmsg($who, "error in server plugin...");
    return;
  }

  if($pid) {
    #parent

    $SIG{CHLD} = sub { wait; };
    return;

  } else {
    # child

    my($remote,$port,$iaddr,$paddr,$proto,$line);
    $remote = $max;
    ($port = $event->{args}[0]) =~ tr/[A-Z]/[a-z]/;
    if ($port =~ /.*:/) { $port =~ s/.*://; } else { $port = 80 ; } 

    if(!defined($iaddr = inet_aton($remote))) {
      $conn->privmsg($who, "Could not get address for $remote:$port");
      $conn->{_connected} = 0;
      exit 1;
    }
    if(!defined($paddr = sockaddr_in($port, $iaddr))) {
      $conn->privmsg($who, "Could not get port for $remote");
      $conn->{_connected} = 0;
      exit 1;
    }
    if(!defined($proto = getprotobyname('tcp'))) {
      $conn->privmsg($who, "Could not get tcp protocol");
      $conn->{_connected} = 0;
      exit 1;
    }

    if(!socket(SOCK, PF_INET, SOCK_STREAM, $proto)) {
      $conn->privmsg($who, "Could not open socket to $remote");
      $conn->{_connected} = 0;
      exit 1;
    }
    if(!connect(SOCK, $paddr)) {
      $conn->privmsg($who, "Could not connect to $remote:$port");
      $conn->{_connected} = 0;
      exit 1;
    }

    $msg = "GET /index.html HTTP/1.0\n\n" ;


    if(!send(SOCK, $msg, 0)) {
      $conn->privmsg($who, "Could not send to $remote");
      $conn->{_connected} = 0;
      exit 1;
    }
 
    while($aa = <SOCK>) {
        if ($aa =~ /^.*Server:/) { 
           $conn->privmsg($who,"Scaning http://$remote:$port") ; 
           $conn->privmsg($who,"$aa") ; 
           break ; 
        }
    }


    close SOCK;
    $conn->{_connected} = 0;
    exit 0;
  }

  close SOCK;
}

1;
