# $Id: Plugin.pm,v 1.1.1.1 2002/09/03 09:15:12 tolkien Exp $
#
# ޸ Ȥ  ڷḦ 
#

package Udic::Plugin;

use Perlbot;
use POSIX;
use DB_File;
use vars qw($UDIC_DATA_PATH $MAX_LIST $PER_PAGE $TOTAL_KEY $UDIC_BUG_KEY);

sub get_hooks {
  return { public => \&on_public, msg => \&on_msg };
}

sub on_public {
  my $conn = shift;
  my $event = shift;
#  my $who = $event->{to}[0];
  my $who = $event->nick;

  if ($event->{args}[0] =~ /^-udic/) {
    udic($conn, $event, $who);
  }

}

sub on_msg {
  my $conn = shift;
  my $event = shift;
  my $who = $event->nick;

  if($event->{args}[0] =~ /^-udic/) {
    udic($conn, $event, $who);
  }
}

$UDIC_DATA_PATH = $datadir . "/udic.db";	# Ÿ
$MAX_LIST = 5;
$PER_PAGE = 5;
$TOTAL_KEY = "__total__";
$UDIC_BUG_KEY = "udic_bug";

sub udic {
	# Math handling.
	my $conn = shift;
	my $event = shift;
	my $who = shift;
	my $nick = $event->{nick};

	if (!defined($pid = fork)) {
		$conn->privmsg($who, "error in udic, or something...");
		$conn->{_connected} = 0;
		exit 1;
	}

	if ($pid) { # parent
		$SIG{CHLD} = sub { wait; };
		return;
	} else {
    # child...

	my (%H,$h,$tot,$cmd,$opt,$opts,$optype,$word,$mean,$meaning);
	my ($list_start,$list_end,@sendbuf,$args,@argv,@atmp,$err,$cnt);
	my ($sec,$min,$hour,$mday,$mon,$year,$dummy);

	($sec,$min,$hour,$mday,$mon,$year,$dummy) = localtime(time);
	if ($year < 99) { $year += 2000; } else { $year += 1900; }
	$mon++;

    ($args = $event->{args}[0]) =~ s/^-udic\s*//;

	$err = 0;
	@argv = split(/ /, $args);


	if ($argv[0] =~ /^([-+])([a-zA-Z0-9=,]+)/) {
		$optype = $1;
		$opts = $2;

		shift(@argv);

		# Overwrite
		if ($opts eq 'o') {
			$cmd = 'overwrite';
		}
		# Append
		elsif ($opts eq 'a') {
			$cmd = 'append';
		}
		# Delete
		elsif ($opts =~ /^delete/) {
			$cmd = 'delete';
		}
		# Count Rows
		elsif ($opts eq 'c') {
			$cmd = 'count';
		}
		# List
		elsif ($opts =~ /^l/) {
			if ($opts =~ /=(.*)/) {
				$opt = $1;
			}
			else {
				$opt = shift(@argv);
			}
			if ($opt =~ /(\d+)[,\.\-\~](\d+)/) {
				$list_start = int($1);
				$list_end = int($2);
			}
			elsif ($opt =~ /(\d+)/) {
				$list_start = int($1);
				$list_end = $list_start + $MAX_LIST;
			}
			else {
				$list_start = 1;
				$list_end = $MAX_LIST;
			}
			$cmd = 'list';
		}
		# Append
		elsif ($opts =~ /^(\d+)/) {
			$opt = ($1 ? $1 : 1);
			if ($optype eq '+') { $cmd = 'search'; }
			else { $cmd = 'append'; }
		}
		else {
			$err = "    $optype$opts";
		}

		$word = shift(@argv);
		$meaning = join(' ', @argv);

		if (($cmd eq 'overwrite' or $cmd eq 'append') and (!$word || !$meaning)) {
			$err = "Ű Ǵ Ű   Է մϴ.";
		}
	}
	else {
		$word = shift(@argv);
		$meaning = join(' ', @argv);
		if ($meaning) {
			$opt = 1;
			$cmd = 'append';
		}
		elsif (!$word) {
			$cmd = 'count';
		}
		else {
			$cmd = 'search';
		}
	}

	if ($err) {
		$conn->privmsg($who, ": $err");
		$conn->{_connected} = 0;
		exit 1;
	}

	$meaning = sprintf("%04d/%02d/%02d,%s: %s", $year,$mon,$mday,$nick,$meaning);

	$h = tie %H,"DB_File",$UDIC_DATA_PATH,O_CREAT|O_RDWR,0644,$DB_BTREE;
	unless ($h) {
		$conn->privmsg($who, ": $!");
		$conn->{_connected} = 0;
		exit 1;
	}

	# total row count
	$ret = $h->get($TOTAL_KEY, $tot);
	if ($ret) {
		$tot = 0;
	}

	if ($cmd eq 'count') {
		push(@sendbuf, "ü $tot  Ÿ Ǿֽϴ.");
	}
	else {
		if ($cmd eq 'append') {
			my($cnt_row) = 1;
			my($insert) = 0;

			if (!($ret = $h->get($word, $mean))) {
				my(@pair) = split(/\n/, $mean);
				foreach (@pair) {
					if ($cnt_row == $opt) {
						push(@atmp, $meaning);
						$insert = 1;
					}
					push(@atmp, $_);
					$cnt_row++;
				}
			}
			push(@atmp, $meaning) unless ($insert);
			# ǰ, ̹  ̸
			if (!$h->put($word, join("\n", @atmp))) {
				if ($ret and !$insert) {
					$h->put($TOTAL_KEY, ++$tot);
					push(@sendbuf, "Է¿Ϸ:  $tot  Ÿ Ǿֽϴ.");
				}
				for($i=0,my $line=""; $i<=$#atmp && $i < 10; $i++) {
					$line = ($i+1).") $atmp[$i]";
					push(@sendbuf, $line);
				}
			}
			else {
				push(@sendbuf, "Է¿: ׸Ʈ Ű '$UDIC_BUG_KEY'  ּ");
			}
		}
		elsif ($cmd eq 'overwrite') {
			$ret = $h->get($word, $mean);
			if ($h->put($word, $meaning)) {
				push(@sendbuf, "Է¿: ׸Ʈ Ű '$UDIC_BUG_KEY'  ּ");
			}
			else {
				if (!$ret) { $meaning = " ϴ."; }
				else {
					$h->put($TOTAL_KEY, ++$tot);
					$meaning = "$tot ° Ͽϴ.";
				}
				push(@sendbuf, "Է¿Ϸ: '$word' ܾ $meaning");
			}
		}
		elsif ($cmd eq 'delete') {
			#  Nickθ 
			if (!$h->get($word, $mean)) {
				my (@means);
				@atmp = split(/\n/, $mean);
				foreach $line (@atmp) {
					if ($line =~ m#(\d+)/(\d+)/(\d+),(.*): (.*)#) {
						if ($nick ne $4) {
							push(@means, $line);
						}
					}
				}
				if ($#means < 0) {
					$h->del($word);
					$h->put($TOTAL_KEY, --$tot);
				}
				else {
					$h->put($word, join("\n", @means));
				}
			}
		}
		elsif ($cmd eq 'list') {
			if ($list_start <= 0) { $list_start = 1; }
			if (($list_end - $list_start) > 10) {
				push(@sendbuf, "[*] $MAX_LIST     ֽϴ.");
				$list_end = $list_start + $MAX_LIST;
			}
			elsif ($list_end <= $list_start) {
				push(@sendbuf, "[*]  ڴ  ں Ŀ մϴ.");
				$list_end = $list_start + $MAX_LIST;
			}
			elsif ($list_start > $tot) {
				push(@sendbuf, "[*] Ǿִ Ÿ ū ȣ ûϼ̽ϴ.");
				$list_start = ($tot > $MAX_LIST) ? $MAX_LIST : 1;
				$list_end = $tot;
			}
			if ($list_end > $tot) { $list_end = $tot; }

			my ($k, $v, $line);

			$cnt = 1;

			$line = "[*] $list_start/$tot ~ $list_end/$tot Ϻ";
			push(@sendbuf, $line);
			for (my $st=$h->seq($k,$v,R_FIRST); !$st; $st=$h->seq($k,$v,R_NEXT), $cnt++) {
				if ($k eq $TOTAL_KEY) { $cnt--; next; }
				if ($cnt >= $list_start && $cnt <= $list_end) {
					@atmp = split(/\n/, $v);
					$line = "$cnt) $k = $atmp[0]";
					push(@sendbuf, $line);
				}
				elsif ($cnt > $list_end) { last; }
			}
		}
		elsif ($cmd eq 'search') {
			if ($word =~ /(.*)\*$/) {
				$word = $k = $1;
				$v = 0;
				for (my $st=$h->seq($k,$v,R_CURSOR),$cnt = 0;
					($cnt < 5) && ($k =~ /$word/) && !$st;
					$st=$h->seq($k,$v,R_NEXT), $cnt++)
				{
					@atmp = split(/\n/, $v);
					if (!$#atmp) { $line = ($cnt+1).". $k = (1/".($#atmp+1).")$atmp[0]"; }
					else { $line = ($cnt+1).". $k = (1/".($#atmp+1).")$atmp[0]"; }
					push(@sendbuf, $line);
				}
				push(@sendbuf, "<$word*> ˻  $cnt ");
			}
			elsif (!$h->get($word, $mean)) {
				my(@pair) = split(/\n/, $mean);
				my($maxrow) = ($#pair + 1);
				my($line, $maxpage);
				my $row = 0;

				if ($optype eq '+') {
					$opt = int($opt);
					$opt-- if ($opt);
					$row = 0 if (($row = ($opt * $PER_PAGE)) > $maxrow);
				}

				for (my $i = 0; $i < $PER_PAGE && ($i+$row) < $maxrow; $i++) {
					$line = ($i+$row+1)."/$maxrow)$optype $pair[$row+$i]";
					push(@sendbuf, $line);
				}
			}
			else {
				push(@sendbuf, "$word:  ʴ ܾ Դϴ.");
			}
		}
	}
	$h->sync();
	untie %H;
	# end of udic code

    foreach $line (@sendbuf) {
      chomp $line;
      $conn->privmsg($who, $line);
    }

    $conn->{_connected} = 0;

    exit 0;

	} # child
}

1;
