# Andrew Burke <burke@pas.rochester.edu>
#
# Gets the weather...
#
# ported/mangled from:
#
# the original is back!
# weather.pl does what it says.. gets you the weather
# using www.weather.com, it brings you the local
# forecast minus the hassle at www.weather.com
# the only thing you need to edit is this:
# http://www.weather.com/weather/cities/us_ny_white_plains.html
# is the url for getting weather in the city of White Plains
# which is in the Sate of New York
# edit the $city and $state variables for your home city
# (use www.weather.com to find which is the one you want to go on)
# enjoy!   spline!spline@linuxwarez.com
# also look for my forecast.pl 

package Weather::Plugin;

use Perlbot;

use Socket;
use POSIX;

sub get_hooks {
  return { public => \&on_public, msg => \&on_msg };
}

sub on_public {
  my $conn = shift;
  my $event = shift;
  my $args;

  ($args = $event->{args}[0]) =~ tr/[A-Z]/[a-z]/;

  if($args =~ /^-weather/) {
    get_weather($conn, $event, $event->{to}[0]);
  }
}

sub on_msg {
  my $conn = shift;
  my $event = shift;
  my $args;
 
  ($args = $event->{args}[0]) =~ tr/[A-Z]/[a-z]/;

  if($args =~ /^-weather/) {
    get_weather($conn, $event, $event->nick);
  }
}

sub get_weather {
  my $conn = shift;
  my $event = shift;
  my $who = shift;

  if(!defined($pid = fork)) {
    $conn->privmsg($chan, "error in weather plugin...");
    return;
  }

  if($pid) {
    #parent

    $SIG{CHLD} = sub { wait; };
    return;

  } else {
    # child

    my $args;
    ($args = $event->{args}[0]) =~ tr/[A-Z]/[a-z]/;
    $args =~ s/^-weather\s*//;
    

    $args =~ s/\s*,\s*/,/g;   # match zero or more spaces, then comma, then
                              # zero or more spaces... replace it w/ a comma

    $args =~ s/\s+/+/g;       # match one or more spaces and replace it
                              # w/ an _... ie: new york, ny becomes:
                              # new_york,ny

    $args =~ tr/[A-Z]/[a-z]/; # get rid of capitals

		my ($city, $state, $country) = split(',', $args);
		if ($country eq '') { $country = 'us'; }

		my ($remote,$port,$iaddr,$paddr,$proto,$line);
		$remote = "www.weather.com";
		$port = "80";

		if (!defined($iaddr = inet_aton($remote))) {
			$conn->privmsg($who, "Could not get address of $remote");
			$conn->{_connected} = 0;
			exit 1;
		}
		if (!defined($paddr = sockaddr_in($port, $iaddr))) {
			$conn->privmsg($who, "Could not get port address of $remote");
			$conn->{_connected} = 0;
			exit 1;
		}      
		if (!defined($proto = getprotobyname('tcp'))) {
			$conn->privmsg($who, "Could not get tcp connection for $remote");
			$conn->{_connected} = 0;
			exit 1;
		}
		if (!socket(SOCK, PF_INET, SOCK_STREAM, $proto)) {
			$conn->privmsg($who, "Could not establish socket connect to $remote");
			$conn->{_connected} = 0;
			exit 1;
		}
		if (!connect(SOCK, $paddr)) {
			$conn->privmsg($who, "Could not establish connection to $remote");
			$conn->{_connected} = 0;
			exit 1;
		}

		$msg = "GET /weather/cities/${country}_${state}_${city}.html HTTP/1.0\n\n";

		if (!send(SOCK, $msg, 0)) {
			$conn->privmsg($who, "Could not establish send to $remote");
			$conn->{_connected} = 0;
			exit 1;
		}
		while ($hrm = <SOCK>) {
	    	if ($hrm =~ /.*zip and city search/) {
				$conn->privmsg($who, "Invalid something... Syntax: -weather <city>, <two char state abbrev>, <optional country two char abbrev>");
				$conn->{_connected} = 0;
				exit 0;
	    	}
			elsif ($hrm =~ /<TITLE>/) {
				if ($hrm =~ /^.*Channel - ([^<]+)/) {
					$location = $1;
				}
			}
			elsif ($hrm =~ />Last updated ([^<]+)/) {
				$update = $1;
			}
			elsif ($hrm =~ /Sunrise:/) {
				if (($hrm = <SOCK>) && ($hrm = <SOCK>) && ($hrm =~ />([0-9]{1,2}:[0-9]{1,2} [ap]m)</)) {
					$sunrise = $1;
				}
			}
			elsif ($hrm =~ /Sunset:/) {
				if (($hrm = <SOCK>) && ($hrm = <SOCK>) && ($hrm =~ />([0-9]{1,2}:[0-9]{1,2} [ap]m)</)) {
					$sunset = $1;
				}
			}
			# status deleted
			elsif ($hrm =~ /Temp:/) {
				if (($hrm = <SOCK>) && ($hrm = <SOCK>) && ($hrm =~ />(\d+)&deg;/)) {
					$temp = $1;
				}
			}
			elsif ($hrm =~ /Wind:/) {
				if (($hrm = <SOCK>) && ($hrm = <SOCK>) && ($hrm =~ />([^<]+)/)) {
					$wind = $1;
				}
			}
			elsif ($hrm =~ /Humidity:/) {
				if (($hrm = <SOCK>) && ($hrm = <SOCK>) && ($hrm =~ />([^<]+)/)) {
					$humidity = $1;
				}
			}
			elsif ($hrm =~ /Barometer:/) {
				if (($hrm = <SOCK>) && ($hrm = <SOCK>) && ($hrm =~ />([^<]+)/)) {
					$bar = $1;
				}
			}
		}
		
#ok done getting the info..
		if ($sunrise ne '' || $sunset ne '') {
			$conn->privmsg($who, "${location} / Sunrise: $sunrise / Sunset: $sunset\n");
		}

		#be nice to people using the right system...

		my $celsius = ($temp - 32) * (5/9);
		$celsius = sprintf("%.2f", $celsius);

		my ($kph) = $wind =~ /at (\d+) mph/;
		$kph = 1.6 * $kph;

		my ($metric_bar) = $bar =~ /(.*?)\s+/;
		$metric_bar = 2.54 * $metric_bar;

		$conn->privmsg($who, "${location} / Temp: ${temp}F (${celsius}C) / Wind: $wind (${kph} kph)");
		$conn->privmsg($who, "${location} / Humidity: $humidity / Barometer: $bar ($metric_bar cm)");

		$conn->{_connected} = 0;
		exit 0;

  }
}

1;
