# Joh Yong-iL <tolkien@nownuri.net>
#
# does a whois...

package Whois::Plugin;

use Perlbot;
use POSIX;
use lib $plugindir . '/Whois/';
use Whois;

sub get_hooks {
  return { public => \&on_public, msg => \&on_msg};
}

sub on_public {
  my $conn = shift;
  my $event = shift;

  (my $args = $event->{args}[0]) =~ tr/[A-Z]/[a-z]/;

  if($args =~ /^-whois\s*/) {
    whois_p($conn, $event, $event->{to}[0]);
  }
}

sub on_msg {
  my $conn = shift;
  my $event = shift;

  (my $args = $event->{args}[0]) =~ tr/[A-Z]/[a-z]/;

  if($args =~ /^-whois\s*/) {
    whois_p($conn, $event, $event->nick);
  }
}

sub whois_p {
  my $conn = shift;
  my $event = shift;
  my $who = shift;
  my $in;
  my $pid;

  if (!defined($pid = fork)) {
    $conn->privmsg($who, "error in whois... weird.");
    return;
  }

  if ($pid) {
    # parent

    $SIG{CHLD} = sub { wait; };
    return;

  } else {
    # child...

    (my $in = $event->{args}[0]) =~ s/^-whois\s*//;

    if ($in ne '') {
	$rv = new Whois($in) or goto EXIT_P;
	if ($rv->ok) {
	  # print results
	  $conn->privmsg($who, "  : " . $rv->domain . " / " .
		$rv->registrant . " / " . $rv->country);
	  $conn->privmsg($who, "  : " . $rv->admin .
		" <" . $rv->email. ">");
	  $conn->privmsg($who, "ȭȣ: " . $rv->phone .
		", Fax) " . $rv->fax);
	  $conn->privmsg($who, "    ¥: " .
		strftime('%Y-%m-%d', localtime($rv->created)) . " | " .
		strftime('%Y-%m-%d', localtime($rv->updated)) . " | " .
		strftime('%Y-%m-%d', localtime($rv->expires)));
	  $conn->privmsg($who, "ϱ: " . $rv->registrar .
		" (" . $rv->whois_server . ")");
          do {
		$conn->privmsg($who, "Ӽ: " . $_->{host} .
			" [" . $_->{ip} . "]");
	  } foreach (@{$rv->name_servers});
	} else {
	  $conn->privmsg($who,  "No match for $in\n");
	}
    }

  EXIT_P:
    $conn->{_connected} = 0;
    exit 0;                     # kill child
  }
}

1;
