# Kilsang Kang <pushnpop@hanrmi.com>
#
# Wise
#

package Wise::Plugin;

use Perlbot;
use POSIX;
use DB_File;
use vars qw($WISE_DATA_PATH, $MAX_KEY);

sub get_hooks {
  return { public => \&on_public, msg => \&on_msg };
}

sub on_public {
  my $conn = shift;
  my $event = shift;
  my $who = $event->{to}[0];

  if ($event->{args}[0] =~ /^,wise/) {
    math($conn, $event, $who);
  }

}

sub on_msg {
  my $conn = shift;
  my $event = shift;
  my $who = $event->nick;

  if($event->{args}[0] =~ /^,wise/) {
    math($conn, $event, $who);
  }
}

$WISE_DATA_PATH = "/var/tmp/wise.db";	# Ÿ
$MAX_KEY = "max";

sub math {
	# Math handling.
	my $conn = shift;
	my $event = shift;
	my $who = shift;
	my $nick = $event->{nick};

	if (!defined($pid = fork)) {
		$conn->privmsg($who, "error in wise, or something...");
		$conn->{_connected} = 0;
		exit 1;
	}

	if ($pid) { # parent
		$SIG{CHLD} = sub { wait; };
		return;
	} else {
    # child...

#	my($sec,$min,$hour,$mday,$mon,$year,$dummy) = localtime(time);
#	if ($year < 99) { $year += 2000; } else { $year += 1900; }
#	$mon++;

	my (%H,$h,$args,$maxrow,$key,$wise, @sendbuf);
    ($args = $event->{args}[0]) =~ s/^,wise\s*//;

	$h = tie %H,"DB_File",$WISE_DATA_PATH,O_CREAT|O_RDWR,0644,$DB_BTREE;
	unless ($h) {
		$conn->privmsg($who, ": $!");
		$conn->{_connected} = 0;
		exit 1;
	}

	# total row count
	unless ($h->get($MAX_KEY, $maxrow)) {
		# μ
		if (($key = int($args)) && $maxrow >= $key) {
			$h->get($key, $wise);
			push(@sendbuf, $wise);
		}
		elsif ($args != "-c") {
			my @list = $h->get_dup($args);
			foreach (@list) {
				if (!$h->get($_, $wise)) {
					push(@sendbuf, $wise);
				}
				else { last; }
			}
		}
		else {
			do { $key = int(rand $maxrow); } while(!$key);
			$h->get($key, $wise);
			push(@sendbuf, $wise);
		}
	}
	untie %H;

	
	if ($args eq '-c') { $conn->privmsg($who, "count: $maxrow"); }
	foreach (@sendbuf) {
		$conn->privmsg($who, $_);
    }

    $conn->{_connected} = 0;
    exit 0;

	} # child
}

1;
